// =====================================================================================================================
//  fennec, a free and open source game engine
//  Copyright © 2025 - 2026  Medusa Slockbower
//
//  This program is free software: you can redistribute it and/or modify
//  it under the terms of the GNU General Public License as published by
//  the Free Software Foundation, either version 3 of the License, or
//  (at your option) any later version.
//
//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU General Public License for more details.
//
//  You should have received a copy of the GNU General Public License
//  along with this program.  If not, see <https://www.gnu.org/licenses/>.
// =====================================================================================================================

#ifndef FENNEC_TEST_CONTAINERS_SEQUENCE_H
#define FENNEC_TEST_CONTAINERS_SEQUENCE_H
#include <fennec/containers/sequence.h>

namespace fennec
{

namespace test
{

inline void fennec_test_containers_sequence() {
	using type_t = decltype(rand());
	dynarray<type_t> ref;
	sequence<type_t> test;
	const size_t n = 50;

	for (size_t i = 0; i < n; ++i) {
		type_t v = rand();
		ref.push_back(v);
		test.insert(v);
	}

	fennec_test_run(test.size(), n);

	type_t p = -1;
	size_t c = 0;
	for (type_t x : test) {
		assertf(x > p, "Failed Sequence Test!");
		p = x;
		++c;
	}
	fennec_test_run(c, n);

	for (type_t v : ref) {
		assertf(test.contains(v), "Failed Sequence Test!");
		test.erase(v);
	}

	fennec_test_run(test.is_empty(), true);
}

}

}

#endif // FENNEC_TEST_CONTAINERS_SEQUENCE_H